<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Basic Features</TITLE>
<link href="suif1_24.html" rel=Next>
<link href="suif1_22.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_22.html">previous</A>, <A HREF="suif1_24.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC23" HREF="suif1_toc.html#TOC23">Basic Instruction Features</A></H2>
<P>
<A NAME="IDX132"></A>

</P>
<P>
<A NAME="IDX133"></A>
All instructions share some basic features.  This section describes the
fields in the base <CODE>instruction</CODE> class.  Other classes are derived
from the <CODE>instruction</CODE> class to include fields that are specific to
the different instruction formats.

</P>
<P>
Besides the features below, the instructions have ID numbers that can be
used to identify them across passes of the compiler.  This is discussed
in detail elsewhere.  See section <A HREF="suif1_12.html#SEC12">ID Numbers for Tree Nodes and Instructions</A>.

</P>
<P>
<A NAME="IDX134"></A>
The SUIF library also declares an <CODE>instruction_list</CODE> class for
working with lists of pointers to instructions.  This class is not used
much within the library itself because SUIF does not store instructions
directly on lists.  Even with the flat list form, the instructions are
contained in <CODE>tree_instr</CODE> nodes, which in turn are stored in lists.
However, it may sometimes be convenient to work with lists of
instruction pointers even if those instructions are actually stored in
<CODE>tree_instr</CODE> nodes.

</P>

<UL>
<LI><A HREF="suif1_24.html#SEC24">Opcodes and Formats</A>: Description of opcode and format enumerations.
<LI><A HREF="suif1_25.html#SEC25">Destination Operands</A>: Conventions for the destination operands.
<LI><A HREF="suif1_26.html#SEC26">Result Types</A>: Specifying the types of the result values.
<LI><A HREF="suif1_27.html#SEC27">Parent Tree Nodes</A>: Back-pointers to the <CODE>tree_instr</CODE> nodes.
<LI><A HREF="suif1_28.html#SEC28">Source Operands</A>: Standard methods for accessing sources.
<LI><A HREF="suif1_29.html#SEC29">Printing Methods</A>: Printing instructions and operands as text.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_22.html">previous</A>, <A HREF="suif1_24.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
